#include "xl_pad.h"

void InitGamePad()
{
	PadInit();

	// set default value
	memset(&p1_pad, 0, sizeof(XL_PAD));
	memset(&p2_pad, 0, sizeof(XL_PAD));
}

void DeinitGamePad()
{
	PadStop();
}

void UpdateGamePad()
{
	// ------------------------------
	// PLAYER 1 PAD
	p1_pad.pad_data = PadRead();

	// PAD_SELECT
	if (p1_pad.pad_data & PAD_SELECT)
	{
		if (p1_pad.select == FALSE)
		{
			p1_pad.select_clicked = TRUE;
			p1_pad.select = TRUE;
		}
		else
		{
			p1_pad.select_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.select = FALSE;
		p1_pad.select_clicked = FALSE;
	}

	// PAD_START
	if (p1_pad.pad_data & PAD_START)
	{
		if (p1_pad.start == FALSE)
		{
			p1_pad.start_clicked = TRUE;
			p1_pad.start = TRUE;
		}
		else
		{
			p1_pad.start_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.start = FALSE;
		p1_pad.start_clicked = FALSE;
	}

	// PAD_UP
	if (p1_pad.pad_data & PAD_UP)
	{
		if (p1_pad.up == FALSE)
		{
			p1_pad.up_clicked = TRUE;
			p1_pad.up = TRUE;
		}
		else
		{
			p1_pad.up_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.up = FALSE;
		p1_pad.up_clicked = FALSE;
	}

	// PAD_DOWN
	if (p1_pad.pad_data & PAD_DOWN)
	{
		if (p1_pad.down == FALSE)
		{
			p1_pad.down_clicked = TRUE;
			p1_pad.down = TRUE;
		}
		else
		{
			p1_pad.down_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.down = FALSE;
		p1_pad.down_clicked = FALSE;
	}

	// PAD_LEFT
	if (p1_pad.pad_data & PAD_LEFT)
	{
		if (p1_pad.left == FALSE)
		{
			p1_pad.left_clicked = TRUE;
			p1_pad.left = TRUE;
		}
		else
		{
			p1_pad.left_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.left = FALSE;
		p1_pad.left_clicked = FALSE;
	}

	// PAD_RIGHT
	if (p1_pad.pad_data & PAD_RIGHT)
	{
		if (p1_pad.right == FALSE)
		{
			p1_pad.right_clicked = TRUE;
			p1_pad.right = TRUE;
		}
		else
		{
			p1_pad.right_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.right = FALSE;
		p1_pad.right_clicked = FALSE;
	}

	// PAD_TRIANGLE
	if (p1_pad.pad_data & PAD_TRIANGLE)
	{
		if (p1_pad.triangle == FALSE)
		{
			p1_pad.triangle_clicked = TRUE;
			p1_pad.triangle = TRUE;
		}
		else
		{
			p1_pad.triangle_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.triangle = FALSE;
		p1_pad.triangle_clicked = FALSE;
	}

	// PAD_CIRCLE
	if (p1_pad.pad_data & PAD_CIRCLE)
	{
		if (p1_pad.circle == FALSE)
		{
			p1_pad.circle_clicked = TRUE;
			p1_pad.circle = TRUE;
		}
		else
		{
			p1_pad.circle_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.circle = FALSE;
		p1_pad.circle_clicked = FALSE;
	}

	// PAD_CROSS
	if (p1_pad.pad_data & PAD_CROSS)
	{
		if (p1_pad.cross == FALSE)
		{
			p1_pad.cross_clicked = TRUE;
			p1_pad.cross = TRUE;
		}
		else
		{
			p1_pad.cross_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.cross = FALSE;
		p1_pad.cross_clicked = FALSE;
	}

	// PAD_SQUARE
	if (p1_pad.pad_data & PAD_SQUARE)
	{
		if (p1_pad.square == FALSE)
		{
			p1_pad.square_clicked = TRUE;
			p1_pad.square = TRUE;
		}
		else
		{
			p1_pad.square_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.square = FALSE;
		p1_pad.square_clicked = FALSE;
	}

	// PAD_L1
	if (p1_pad.pad_data & PAD_L1)
	{
		if (p1_pad.l1 == FALSE)
		{
			p1_pad.l1_clicked = TRUE;
			p1_pad.l1 = TRUE;
		}
		else
		{
			p1_pad.l1_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.l1 = FALSE;
		p1_pad.l1_clicked = FALSE;
	}

	// PAD_R1
	if (p1_pad.pad_data & PAD_R1)
	{
		if (p1_pad.r1 == FALSE)
		{
			p1_pad.r1_clicked = TRUE;
			p1_pad.r1 = TRUE;
		}
		else
		{
			p1_pad.r1_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.r1 = FALSE;
		p1_pad.r1_clicked = FALSE;
	}

	// PAD_L2
	if (p1_pad.pad_data & PAD_L2)
	{
		if (p1_pad.l2 == FALSE)
		{
			p1_pad.l2_clicked = TRUE;
			p1_pad.l2 = TRUE;
		}
		else
		{
			p1_pad.l2_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.l2 = FALSE;
		p1_pad.l2_clicked = FALSE;
	}

	// PAD_R2
	if (p1_pad.pad_data & PAD_R2)
	{
		if (p1_pad.r2 == FALSE)
		{
			p1_pad.r2_clicked = TRUE;
			p1_pad.r2 = TRUE;
		}
		else
		{
			p1_pad.r2_clicked = FALSE;
		}
	}
	else
	{
		p1_pad.r2 = FALSE;
		p1_pad.r2_clicked = FALSE;
	}

	// ------------------------------
	// PLAYER 2 PAD
	p2_pad.pad_data = PadRead2();

	// PAD_SELECT
	if (p2_pad.pad_data & PAD_SELECT)
	{
		if (p2_pad.select == FALSE)
		{
			p2_pad.select_clicked = TRUE;
			p2_pad.select = TRUE;
		}
		else
		{
			p2_pad.select_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.select = FALSE;
		p2_pad.select_clicked = FALSE;
	}

	// PAD_START
	if (p2_pad.pad_data & PAD_START)
	{
		if (p2_pad.start == FALSE)
		{
			p2_pad.start_clicked = TRUE;
			p2_pad.start = TRUE;
		}
		else
		{
			p2_pad.start_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.start = FALSE;
		p2_pad.start_clicked = FALSE;
	}

	// PAD_UP
	if (p2_pad.pad_data & PAD_UP)
	{
		if (p2_pad.up == FALSE)
		{
			p2_pad.up_clicked = TRUE;
			p2_pad.up = TRUE;
		}
		else
		{
			p2_pad.up_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.up = FALSE;
		p2_pad.up_clicked = FALSE;
	}

	// PAD_DOWN
	if (p2_pad.pad_data & PAD_DOWN)
	{
		if (p2_pad.down == FALSE)
		{
			p2_pad.down_clicked = TRUE;
			p2_pad.down = TRUE;
		}
		else
		{
			p2_pad.down_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.down = FALSE;
		p2_pad.down_clicked = FALSE;
	}

	// PAD_LEFT
	if (p2_pad.pad_data & PAD_LEFT)
	{
		if (p2_pad.left == FALSE)
		{
			p2_pad.left_clicked = TRUE;
			p2_pad.left = TRUE;
		}
		else
		{
			p2_pad.left_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.left = FALSE;
		p2_pad.left_clicked = FALSE;
	}

	// PAD_RIGHT
	if (p2_pad.pad_data & PAD_RIGHT)
	{
		if (p2_pad.right == FALSE)
		{
			p2_pad.right_clicked = TRUE;
			p2_pad.right = TRUE;
		}
		else
		{
			p2_pad.right_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.right = FALSE;
		p2_pad.right_clicked = FALSE;
	}

	// PAD_TRIANGLE
	if (p2_pad.pad_data & PAD_TRIANGLE)
	{
		if (p2_pad.triangle == FALSE)
		{
			p2_pad.triangle_clicked = TRUE;
			p2_pad.triangle = TRUE;
		}
		else
		{
			p2_pad.triangle_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.triangle = FALSE;
		p2_pad.triangle_clicked = FALSE;
	}

	// PAD_CIRCLE
	if (p2_pad.pad_data & PAD_CIRCLE)
	{
		if (p2_pad.circle == FALSE)
		{
			p2_pad.circle_clicked = TRUE;
			p2_pad.circle = TRUE;
		}
		else
		{
			p2_pad.circle_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.circle = FALSE;
		p2_pad.circle_clicked = FALSE;
	}

	// PAD_CROSS
	if (p2_pad.pad_data & PAD_CROSS)
	{
		if (p2_pad.cross == FALSE)
		{
			p2_pad.cross_clicked = TRUE;
			p2_pad.cross = TRUE;
		}
		else
		{
			p2_pad.cross_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.cross = FALSE;
		p2_pad.cross_clicked = FALSE;
	}

	// PAD_SQUARE
	if (p2_pad.pad_data & PAD_SQUARE)
	{
		if (p2_pad.square == FALSE)
		{
			p2_pad.square_clicked = TRUE;
			p2_pad.square = TRUE;
		}
		else
		{
			p2_pad.square_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.square = FALSE;
		p2_pad.square_clicked = FALSE;
	}

	// PAD_L1
	if (p2_pad.pad_data & PAD_L1)
	{
		if (p2_pad.l1 == FALSE)
		{
			p2_pad.l1_clicked = TRUE;
			p2_pad.l1 = TRUE;
		}
		else
		{
			p2_pad.l1_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.l1 = FALSE;
		p2_pad.l1_clicked = FALSE;
	}

	// PAD_R1
	if (p2_pad.pad_data & PAD_R1)
	{
		if (p2_pad.r1 == FALSE)
		{
			p2_pad.r1_clicked = TRUE;
			p2_pad.r1 = TRUE;
		}
		else
		{
			p2_pad.r1_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.r1 = FALSE;
		p2_pad.r1_clicked = FALSE;
	}

	// PAD_L2
	if (p2_pad.pad_data & PAD_L2)
	{
		if (p2_pad.l2 == FALSE)
		{
			p2_pad.l2_clicked = TRUE;
			p2_pad.l2 = TRUE;
		}
		else
		{
			p2_pad.l2_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.l2 = FALSE;
		p2_pad.l2_clicked = FALSE;
	}

	// PAD_R2
	if (p2_pad.pad_data & PAD_R2)
	{
		if (p2_pad.r2 == FALSE)
		{
			p2_pad.r2_clicked = TRUE;
			p2_pad.r2 = TRUE;
		}
		else
		{
			p2_pad.r2_clicked = FALSE;
		}
	}
	else
	{
		p2_pad.r2 = FALSE;
		p2_pad.r2_clicked = FALSE;
	}

}
